/*---------------------------------------------------------------------------------


Copyright (C) 2007 Acekard, www.acekard.com

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.


---------------------------------------------------------------------------------*/
#ifndef _NANDDRIVER_H_
#define _NANDDRIVER_H_

#include <nds.h>

#ifdef __cplusplus
extern "C" {
#endif

bool ndInitNAND();

// ߼/ӳ
void ndBuildLUT();

// ߼ֵַַ
// oldPhyAddress Ϊ NULLʾдҪ oldPhyAddress 
// ʹ߿Բ Ϊ FREE  oldPhyAddress ڵ block
// logicBlock [out]  oldPhyAddress ڿʵfreeblockʱ򣬴
// תõ logicBlock ţԱԺдʱԸfreeblockһ

u32 ndLog2Phy( u32 logicAddress, u32 * oldPhyAddress );

// ָ zone Ѱ freeblockֵΧ 0 - 1023
u16 ndSearchFreeBlock( u8 zone, bool markFreeBlkToCfg );

// ݣaddr ֵ ĩ 9 λ0, addr  LBA
void ndReadPages( u32 addr, u32 pageCount, u8 * buffer );

// дݣaddr ֵ ĩ 9 λ0, addr  LBA
void ndWritePages( u32 addr, u32 pageCount, const u8 * data );

// дݣaddr ֵ ĩ 9 λ0, addr  LBAдδɵblock
void ndWritePagesSafe( u32 addr, u32 pageCount, const u8 * data );

// ִ nand ڲ Page Copy һдʱ򣬰old blockݿfree block
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64  page
// srcAddr  destAddr Ӧö
void ndNandMove( u32 srcAddr, u32 destAddr, u8 pageCount );

//  ڲ PageCopy ޷ʹõʱֶsrcַʼ 528 Ϊλ page destַ
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64 2kpage512Ҳպ256
void ndCopyPages( u32 srcAddr, u32 destAddr, u8 pageCount );

//  ڲ PageCopy ޷ʹõʱֶsrcַʼ 528 Ϊλ page destַ
// pageCount ָжٸ512 page
// startSubPage ָӵһ2k pageĸ512k pageʼ
// ڶ block ֮俽 64 2kpage512Ҳպ256
void ndCopyPages2K( u32 srcAddr, u32 destAddr, u8 pageCount );

// βǽϴεWriteβWrite(Read)
// ôִndFinishPartialCopyѸղŰƵǸblockĺ벿ݿµblock
void ndFinishPartialCopy();

/*

*/
void ndReplaceBlock( u32 oldBlockAddr );

// дǷ ecc 
//  ecc ˵ɿܲȶ
// ôndReplaceBlock()Ѿɿ鿽¿飬ɿΪ飬д 2 bit ecc error
// ô¼ǸpageeccѴŴд¿飬ⶪʧ
// ֵ 0  no error
//          1  1 bit ecc error
//          2  2 bit ecc error
bool ndCheckError();
/*

*/

u8 getNandDriverVer();

#ifdef __cplusplus
}
#endif

#endif//_NANDDRIVER_H_
